=== debian/changelog ===
catch2 (3.7.1-0.6) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change upload for IEEE long double on ppc64el.

 -- Matthias Klose <doko@debian.org>  Thu, 04 Sep 2025 16:25:56 +0200

catch2 (3.7.1-0.5) unstable; urgency=medium

  * Non-maintainer upload.
  * Add hardening=+pie to DEB_BUILD_MAINT_OPTIONS (Closes: #1095522)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 08 Feb 2025 18:38:12 +0100

catch2 (3.7.1-0.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Add the "allow-stderr" restriction for the SelfTest autopkgtest: on certain
    architectures GCC emits warnings about very old GCC ABI changes.
  * Append -ffloat-store to the CXXFLAGS on any i386 architecture, not only on
    Linux.
  * Backport upstream commit a6ee7e20cd4011129816df7992c1a9db2ef4b58f to fix the
    TTY detection on on Hurd; patch
    upstream_Use-isatty-when-using-GNU-libc.patch.

 -- Pino Toscano <pino@debian.org>  Sat, 19 Oct 2024 21:33:48 +0200

catch2 (3.7.1-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/rules: Fix test failures on i386 (Closes: #1085386)

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 18 Oct 2024 20:40:08 +0200

catch2 (3.7.1-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches: Increase alignment to maximum to work around build issues
    (Closes: #1084909)
  * debian/rules: Build without -Werror

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 18 Oct 2024 19:30:29 +0200

catch2 (3.7.1-0.1) unstable; urgency=medium

  * Non-maintainer upload

  [ Mathieu Mirmont ]
  * control: remove Multi-arch: foreign (Closes: #1057948)

  [ Stephan Lachnit ]
  * New upstream version 3.7.1

 -- Stephan Lachnit <stephanlachnit@debian.org>  Sun, 06 Oct 2024 09:33:35 +0200

catch2 (3.4.0-2) unstable; urgency=medium

  * control: rename package to allow for smoother transition (Closes: #1055237)
  * tests/SelfTest: build & run upstream test tool
  * NEWS: add a link to the v2-to-v3 migration file

 -- Mathieu Mirmont <mat@parad0x.org>  Sun, 19 Nov 2023 21:48:13 +0100
