=== debian/control ===
Source: catch2
Section: devel
Priority: optional
Maintainer: Mathieu Mirmont <mat@parad0x.org>
Build-Depends: cmake, debhelper-compat (= 13), python3
Standards-Version: 4.6.2
Homepage: https://github.com/catchorg/Catch2
Vcs-Browser: https://salsa.debian.org/debian/catch2
Vcs-Git: https://salsa.debian.org/debian/catch2.git
Rules-Requires-Root: no

Package: libcatch2-dev
Architecture: any
Depends: ${misc:Depends}
Replaces: catch2 (<< 3.4.0-2~)
Breaks: catch2 (<< 3.4.0-2~)
Description: C++ Automated Test Cases in Headers
 Catch2 is mainly a unit testing framework for C++, but it also
 provides basic micro-benchmarking features, and simple BDD macros.
 .
 Catch2's main advantage is that using it is both simple and natural.
 Test names do not have to be valid identifiers, assertions look like
 normal C++ boolean expressions, and sections provide a nice and local
 way to share set-up and tear-down code in tests.
 .
 If you've been using Catch2 v2, please see the migrate-v2-to-v3.md
 file in the package documentation. v3 brings a bunch of significant
 changes, the big one being that Catch2 is no longer a single-header
 library. Catch2 now behaves as a normal library, with multiple
 headers and separately compiled implementation.

Package: catch2
Depends: libcatch2-dev, ${misc:Depends}
Architecture: all
Section: oldlibs
Description: C++ Automated Test Cases in Headers (transitional package)
 This is a transitional package. It can safely be removed.
