=== debian/tests/control ===
Tests: SelfTest
Depends: cmake, pkgconf, make, g++, libcatch2-dev
Restrictions: allow-stderr
